<template>
    <div>
        <v-card class="mx-auto" max-width="800">
            <v-container>
                <v-row v-for="orderInf in OrderInfo" :key="orderInf.id" color="#333">
                    <v-col cols="12" md="6" v-if="orderInf.name.length > 0"
                        ><span style="color: #333333; font-weight: bold;">Recibe:</span> {{ orderInf.name }}
                    </v-col>
                    <v-col cols="12" md="6" v-if="orderInf.phone.length > 0"
                        ><span style="color: #333333; font-weight: bold;">Teléfono: </span>{{ orderInf.phone }}</v-col
                    >
                    <v-col cols="12" md="6" v-show="orderInf.type === TypeOrder.DELIVERY">
                        <div>
                            <span style="color: #333333; font-weight: bold;" v-if="orderInf.methodPayment.length > 0"
                                >Forma de pago:
                            </span>
                            {{ orderInf.methodPayment }}
                        </div>
                        <div>
                            <span style="color: #333333; font-weight: bold;" v-if="orderInf.cashInfo.length > 0"
                                >A pagar con:
                            </span>
                            {{ orderInf.cashInfo }}
                        </div>
                    </v-col>
                    <v-col cols="12" md="6">
                        <div>
                            <div v-if="orderInf.type === TypeOrder.DELIVERY">
                                <span style="color: #333333; font-weight: bold;">Subtotal:</span>
                                {{ orderInf.subtotal }}
                            </div>
                            <div v-if="orderInf.type === TypeOrder.DELIVERY">
                                <span style="color: #333333; font-weight: bold;">Costo envío:</span>
                                {{ deliveryCost }}
                            </div>
                            <span style="color: #333333; font-weight: bold;">Monto total:</span>
                            <label> {{ orderInf.total }}</label>
                        </div>
                    </v-col>
                    <v-col cols="12" md="12" v-if="orderInf.type === TypeOrder.DELIVERY"
                        ><span style="color: #333333; font-weight: bold;">Direccion de entrega:</span>
                        <span>
                            Calle: {{ orderInf.address.street ? orderInf.address.street + ',' : '' }} Lote:{{
                                orderInf.address.number ? orderInf.address.number + ',' : ''
                            }}
                            Mza:{{
                                orderInf.address.extNumber ? orderInf.address.extNumber + ',' : ''
                            }}
                            (Región/supermanzana) : {{ orderInf.address.region ? orderInf.address.region + ',' : '' }}
                            {{ orderInf.address.locality ? orderInf.address.locality + ',' : '' }}
                            {{ orderInf.address.state }} {{ orderInf.address.country }}
                        </span>
                        <v-spacer></v-spacer>
                        <span>Referencias: {{ orderInf.address.references }}</span>
                    </v-col>
                </v-row>
            </v-container>

            <div v-for="dish in dishes" :key="dish.id">
                <v-list
                    dense
                    rounded
                    :color="dish.type === ItemType.PRODUCT ? '#fff9c4' : ''"
                    style=" color:black; font-weight: bold"
                >
                    <div v-if="dish.type === ItemType.PRODUCT">
                        <v-row>
                            <v-list-item-content class="list-group-txt" v-show="dish.category.length > 0">
                                <v-col cols="12">
                                    Categoria: <span class="list-item-txt">{{ dish.category }}</span>
                                </v-col>
                            </v-list-item-content>
                            <v-list-item-content class="list-group-txt" v-show="dish.subcategory.length > 0">
                                <v-col cols="12">
                                    Subcategoria: <span class="list-item-txt">{{ dish.subcategory }}</span>
                                </v-col>
                            </v-list-item-content>
                            <v-list-item-content class="list-group-txt" v-show="dish.name !== 'Pasar a Recoger'"
                                ><v-col cols="12">
                                    {{ dish.type === ItemType.PRODUCT ? 'Producto:' : 'Servicio:' }}
                                    <span class="list-item-txt">{{ dish.name }}</span></v-col
                                ></v-list-item-content
                            >
                        </v-row>
                        <v-row>
                            <v-list-item-content style="color: #333; font-size: 15px; font-style: inherit;">
                                <v-col cols="12" v-show="dish.type === ItemType.PRODUCT">
                                    Cantidad : <span class="list-item-txt">{{ dish.quantity }}</span></v-col
                                >
                            </v-list-item-content>
                            <v-list-item-content class="list-group-txt"
                                ><v-col cols="12" v-show="dish.price > 0"
                                    >Precio unitario: <span class="list-item-txt">${{ dish.price }}</span></v-col
                                ></v-list-item-content
                            >
                            <v-list-item-content style="color: #333; font-size: 15px; font-style: inherit;">
                                <v-col cols="12" v-show="dish.type === ItemType.PRODUCT">
                                    Total : <span class="list-item-txt">${{ dish.quantity * dish.price }}</span></v-col
                                >
                            </v-list-item-content>
                        </v-row>
                        <v-row>
                            <v-list-item-content class="list-group-txt"
                                ><v-col cols="12" v-if="dish.details.length > 0"
                                    >Detalle: <span class="list-item-txt">{{ dish.details }}</span></v-col
                                ></v-list-item-content
                            >
                        </v-row>
                    </div>
                    <v-divider></v-divider>
                </v-list>
                <ingredient-item :order-id="orderId" :dis-id="dish.id" :order-type="dish.type"></ingredient-item>
                <span v-show="false"> {{ priceOfService(dish.type, dish.price) }} </span>
            </div>
        </v-card>
    </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import { ItemType, OrderDish } from '@/model/order/OrderDish';
import { db } from '@/config/firebase';
import { ORDER_DISH, ORDERS } from '@/config/collectionsName';
import { serializeOrderDish } from '@/config/serializables';
import IngredientItem from '@/components/order/IngredientItem.vue';
import { Order, TypeOrder } from '@/model/order/Order';

@Component({
    components: {
        IngredientItem
    }
})
export default class DishItem extends Vue {
    @Prop({ default: '' })
    readonly orderId!: string;
    readonly dishes: OrderDish[] = [];

    @Prop({ default: [] })
    orderList!: Order[];

    deliveryCost = 0;
    auxPlusPriceService = 0;
    subtotal = 0;

    totalDelivery = 0;
    totalLocal = 0;

    ItemType = ItemType;
    TypeOrder = TypeOrder;

    created() {
        this.$bind(
            'dishes',
            db
                .collection(ORDERS)
                .doc(this.orderId)
                .collection(ORDER_DISH),
            { serialize: serializeOrderDish }
        );
    }

    get OrderInfo(): Order[] {
        return this.orderList.filter(orderlist => orderlist.id === this.orderId);
    }

    priceOfService(type: string, priceOfService: string) {
        if (type == TypeOrder.DELIVERY || type == TypeOrder.COLLECT) {
            this.deliveryCost = Number(priceOfService);
        }
    }
}
</script>

<style type="scss">
.list-group-txt {
    color: black;
}
.v-chip.v-chip--outlined.v-chip.v-chip {
    background-color: #fbc02d !important;
    border-radius: 40px;
}
.v-list--nav.v-list--dense .v-list-item:not(:last-child):not(:only-child),
.v-list--nav .v-list-item--dense:not(:last-child):not(:only-child),
.v-list--rounded.v-list--dense .v-list-item:not(:last-child):not(:only-child),
.v-list--rounded .v-list-item--dense:not(:last-child):not(:only-child) {
    background-color: #e8eaf6;
    width: 100%;
}
.list-item-txt {
    color: black;
    font-weight: normal;
    padding-left: 5px;
}
</style>
